(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('svelte/internal'), require('svelte')) :
  typeof define === 'function' && define.amd ? define(['svelte/internal', 'svelte'], factory) :
  (global = global || self, global.LazyImage = factory(global.internal, global.svelte));
}(this, function (internal, svelte) { 'use strict';

  /* src/index.svelte generated by Svelte v3.6.5 */

  function create_fragment(ctx) {
  	var img, dispose;

  	var img_levels = [
  		{ src: ctx.path },
  		{ alt: ctx.alt },
  		{ class: "svelte-lazy-image" },
  		ctx.$$props
  	];

  	var img_data = {};
  	for (var i = 0; i < img_levels.length; i += 1) {
  		img_data = internal.assign(img_data, img_levels[i]);
  	}

  	return {
  		c() {
  			img = internal.element("img");
  			internal.set_attributes(img, img_data);
  			internal.toggle_class(img, "svelte-lazy-image--loaded", ctx.loaded);
  			dispose = internal.listen(img, "load", ctx.handleLoad);
  		},

  		m(target, anchor) {
  			internal.insert(target, img, anchor);
  			ctx.img_binding(img);
  		},

  		p(changed, ctx) {
  			internal.set_attributes(img, internal.get_spread_update(img_levels, [
  				(changed.path) && { src: ctx.path },
  				(changed.alt) && { alt: ctx.alt },
  				{ class: "svelte-lazy-image" },
  				(changed.$$props) && ctx.$$props
  			]));

  			if (changed.loaded) {
  				internal.toggle_class(img, "svelte-lazy-image--loaded", ctx.loaded);
  			}
  		},

  		i: internal.noop,
  		o: internal.noop,

  		d(detaching) {
  			if (detaching) {
  				internal.detach(img);
  			}

  			ctx.img_binding(null);
  			dispose();
  		}
  	};
  }

  function instance($$self, $$props, $$invalidate) {
  	let observerCallback = function(entries, observer) {
      entries.forEach(entry => {
        if (entry.isIntersecting) {
          $$invalidate('intersected', intersected = true);
          observer.unobserve(imgElement);
        }
      });
    };

    let { placeholder, src, alt } = $$props;

    let imgElement;
    let path;

    let observer = new IntersectionObserver(observerCallback);
    let intersected = false;
    let loaded = false;

    svelte.onMount(() => {
      observer.observe(imgElement);

      return () => {
        observer.unobserve(imgElement);
      };
    });

    function handleLoad() {
      if (!loaded && path === src) {
        $$invalidate('loaded', loaded = true);
      }
    }

  	function img_binding($$value) {
  		internal.binding_callbacks[$$value ? 'unshift' : 'push'](() => {
  			$$invalidate('imgElement', imgElement = $$value);
  		});
  	}

  	$$self.$set = $$new_props => {
  		$$invalidate('$$props', $$props = internal.assign(internal.assign({}, $$props), $$new_props));
  		if ('placeholder' in $$new_props) $$invalidate('placeholder', placeholder = $$new_props.placeholder);
  		if ('src' in $$new_props) $$invalidate('src', src = $$new_props.src);
  		if ('alt' in $$new_props) $$invalidate('alt', alt = $$new_props.alt);
  	};

  	$$self.$$.update = ($$dirty = { intersected: 1, src: 1, placeholder: 1 }) => {
  		if ($$dirty.intersected || $$dirty.src || $$dirty.placeholder) { {
          $$invalidate('path', path = intersected ? src : placeholder);
        } }
  	};

  	return {
  		placeholder,
  		src,
  		alt,
  		imgElement,
  		path,
  		loaded,
  		handleLoad,
  		$$props,
  		img_binding,
  		$$props: $$props = internal.exclude_internal_props($$props)
  	};
  }

  class Index extends internal.SvelteComponent {
  	constructor(options) {
  		super();
  		internal.init(this, options, instance, create_fragment, internal.safe_not_equal, ["placeholder", "src", "alt"]);
  	}
  }

  return Index;

}));
