import { SvelteComponent, init, safe_not_equal, assign, element, set_attributes, toggle_class, listen, insert, get_spread_update, noop, detach, exclude_internal_props, binding_callbacks } from 'svelte/internal';
import { onMount } from 'svelte';

/* src/index.svelte generated by Svelte v3.6.5 */

function create_fragment(ctx) {
	var img, dispose;

	var img_levels = [
		{ src: ctx.path },
		{ alt: ctx.alt },
		{ class: "svelte-lazy-image" },
		ctx.$$props
	];

	var img_data = {};
	for (var i = 0; i < img_levels.length; i += 1) {
		img_data = assign(img_data, img_levels[i]);
	}

	return {
		c() {
			img = element("img");
			set_attributes(img, img_data);
			toggle_class(img, "svelte-lazy-image--loaded", ctx.loaded);
			dispose = listen(img, "load", ctx.handleLoad);
		},

		m(target, anchor) {
			insert(target, img, anchor);
			ctx.img_binding(img);
		},

		p(changed, ctx) {
			set_attributes(img, get_spread_update(img_levels, [
				(changed.path) && { src: ctx.path },
				(changed.alt) && { alt: ctx.alt },
				{ class: "svelte-lazy-image" },
				(changed.$$props) && ctx.$$props
			]));

			if (changed.loaded) {
				toggle_class(img, "svelte-lazy-image--loaded", ctx.loaded);
			}
		},

		i: noop,
		o: noop,

		d(detaching) {
			if (detaching) {
				detach(img);
			}

			ctx.img_binding(null);
			dispose();
		}
	};
}

function instance($$self, $$props, $$invalidate) {
	let observerCallback = function(entries, observer) {
    entries.forEach(entry => {
      if (entry.isIntersecting) {
        $$invalidate('intersected', intersected = true);
        observer.unobserve(imgElement);
      }
    });
  };

  let { placeholder, src, alt } = $$props;

  let imgElement;
  let path;

  let observer = new IntersectionObserver(observerCallback);
  let intersected = false;
  let loaded = false;

  onMount(() => {
    observer.observe(imgElement);

    return () => {
      observer.unobserve(imgElement);
    };
  });

  function handleLoad() {
    if (!loaded && path === src) {
      $$invalidate('loaded', loaded = true);
    }
  }

	function img_binding($$value) {
		binding_callbacks[$$value ? 'unshift' : 'push'](() => {
			$$invalidate('imgElement', imgElement = $$value);
		});
	}

	$$self.$set = $$new_props => {
		$$invalidate('$$props', $$props = assign(assign({}, $$props), $$new_props));
		if ('placeholder' in $$new_props) $$invalidate('placeholder', placeholder = $$new_props.placeholder);
		if ('src' in $$new_props) $$invalidate('src', src = $$new_props.src);
		if ('alt' in $$new_props) $$invalidate('alt', alt = $$new_props.alt);
	};

	$$self.$$.update = ($$dirty = { intersected: 1, src: 1, placeholder: 1 }) => {
		if ($$dirty.intersected || $$dirty.src || $$dirty.placeholder) { {
        $$invalidate('path', path = intersected ? src : placeholder);
      } }
	};

	return {
		placeholder,
		src,
		alt,
		imgElement,
		path,
		loaded,
		handleLoad,
		$$props,
		img_binding,
		$$props: $$props = exclude_internal_props($$props)
	};
}

class Index extends SvelteComponent {
	constructor(options) {
		super();
		init(this, options, instance, create_fragment, safe_not_equal, ["placeholder", "src", "alt"]);
	}
}

export default Index;
